#include <stdio.h>
#include <string.h>
#include "allegro.h"


/*
 *	VESAAllegrovesainfo.c炢܂BӁB
 */


typedef unsigned long  DWORD;
typedef unsigned short	WORD;
typedef unsigned char	BYTE;
__extension__ typedef unsigned long long	QWORD;


#define MASK_LINEAR(addr)	  (addr & 0x000FFFFF)
#define RM_TO_LINEAR(addr)	  (((addr & 0xFFFF0000) >> 12) + (addr & 0xFFFF))
#define RM_OFFSET(addr) 	  (addr & 0xF)
#define RM_SEGMENT(addr)	  ((addr >> 4) & 0xFFFF)


#ifdef ALLEGRO_GCC
   #define __PACKED__	__attribute__ ((packed))
#else
   #define __PACKED__
#endif

#ifdef ALLEGRO_WATCOM
   #pragma pack (1)
#endif



typedef struct VESA_INFO
{
   unsigned char  VESASignature[4]	   __PACKED__;
   unsigned short VESAVersion		   __PACKED__;
   unsigned long  OEMStringPtr		   __PACKED__;
   unsigned char  Capabilities[4]	   __PACKED__;
   unsigned long  VideoModePtr		   __PACKED__;
   unsigned short TotalMemory		   __PACKED__;
   unsigned short OemSoftwareRev	   __PACKED__;
   unsigned long  OemVendorNamePtr	   __PACKED__;
   unsigned long  OemProductNamePtr    __PACKED__;
   unsigned long  OemProductRevPtr	   __PACKED__;
   unsigned char  Reserved[222] 	   __PACKED__;
   unsigned char  OemData[256]		   __PACKED__;
} VESA_INFO;



typedef struct MODE_INFO
{
   unsigned short ModeAttributes	   __PACKED__;
   unsigned char  WinAAttributes	   __PACKED__;
   unsigned char  WinBAttributes	   __PACKED__;
   unsigned short WinGranularity	   __PACKED__;
   unsigned short WinSize			   __PACKED__;
   unsigned short WinASegment		   __PACKED__;
   unsigned short WinBSegment		   __PACKED__;
   unsigned long  WinFuncPtr		   __PACKED__;
   unsigned short BytesPerScanLine	   __PACKED__;
   unsigned short XResolution		   __PACKED__;
   unsigned short YResolution		   __PACKED__;
   unsigned char  XCharSize 		   __PACKED__;
   unsigned char  YCharSize 		   __PACKED__;
   unsigned char  NumberOfPlanes	   __PACKED__;
   unsigned char  BitsPerPixel		   __PACKED__;
   unsigned char  NumberOfBanks 	   __PACKED__;
   unsigned char  MemoryModel		   __PACKED__;
   unsigned char  BankSize			   __PACKED__;
   unsigned char  NumberOfImagePages   __PACKED__;
   unsigned char  Reserved_page 	   __PACKED__;
   unsigned char  RedMaskSize		   __PACKED__;
   unsigned char  RedMaskPos		   __PACKED__;
   unsigned char  GreenMaskSize 	   __PACKED__;
   unsigned char  GreenMaskPos		   __PACKED__;
   unsigned char  BlueMaskSize		   __PACKED__;
   unsigned char  BlueMaskPos		   __PACKED__;
   unsigned char  ReservedMaskSize	   __PACKED__;
   unsigned char  ReservedMaskPos	   __PACKED__;
   unsigned char  DirectColorModeInfo  __PACKED__;
   unsigned long  PhysBasePtr		   __PACKED__;
   unsigned long  OffScreenMemOffset   __PACKED__;
   unsigned short OffScreenMemSize	   __PACKED__;
   unsigned short LinBytesPerScanLine  __PACKED__;
   unsigned char  BnkNumberOfPages	   __PACKED__;
   unsigned char  LinNumberOfPages	   __PACKED__;
   unsigned char  LinRedMaskSize	   __PACKED__;
   unsigned char  LinRedFieldPos	   __PACKED__;
   unsigned char  LinGreenMaskSize	   __PACKED__;
   unsigned char  LinGreenFieldPos	   __PACKED__;
   unsigned char  LinBlueMaskSize	   __PACKED__;
   unsigned char  LinBlueFieldPos	   __PACKED__;
   unsigned char  LinRsvdMaskSize	   __PACKED__;
   unsigned char  LinRsvdFieldPos	   __PACKED__;
   unsigned long  MaxPixelClock 	   __PACKED__;
   unsigned char  Reserved[190] 	   __PACKED__;
} MODE_INFO;



VESA_INFO vesa_info;
MODE_INFO mode_info;


#define MAX_VESA_MODES 1024


int get_vesa_info(WORD mode[], int *number_of_modes, int *vesa_major_version, DWORD *memsize)
{
	__dpmi_regs r;
	unsigned long mode_ptr;
	int c;
	int modes;

	_farsetsel(_dos_ds);

	for (c=0; c<(int)sizeof(VESA_INFO); c++)
		_farnspokeb(MASK_LINEAR(__tb)+c, 0);

	dosmemput("VBE2", 4, MASK_LINEAR(__tb));

	r.x.ax = 0x4F00;
	r.x.di = RM_OFFSET(__tb);
	r.x.es = RM_SEGMENT(__tb);
	__dpmi_int(0x10, &r);
	if (r.h.ah) {
		printf("Int 0x10, ax=0x4F00 failed! ax=0x%02X\n", r.x.ax);
		return -1;
   }

	dosmemget(MASK_LINEAR(__tb), sizeof(VESA_INFO), &vesa_info);

	if (strncmp(vesa_info.VESASignature, "VESA", 4) != 0) {
		printf("Bad VESA signature! (%4.4s)\n", vesa_info.VESASignature);
		return -1;
	}

	_farsetsel(_dos_ds);

	modes = 0;
	mode_ptr = RM_TO_LINEAR(vesa_info.VideoModePtr);
	mode[modes] = _farnspeekw(mode_ptr);

	while (mode[modes] != 0xFFFF) {
		modes++;
		mode_ptr += 2;
		mode[modes] = _farnspeekw(mode_ptr);
	}

	printf("VESAVersion:\t%d.%d\n", vesa_info.VESAVersion>>8, vesa_info.VESAVersion&0xFF);
	printf("TotalMemory:\t%dK\n", vesa_info.TotalMemory*64);

	*number_of_modes = modes;
	*vesa_major_version = vesa_info.VESAVersion >> 8;
	*memsize			= vesa_info.TotalMemory * 64 * 1024;

	return 0;
}














int get_mode_info(int mode, DWORD *phys_base_ptr)
{
	__dpmi_regs r;
	char color_desc[80];
	int c;

	_farsetsel(_dos_ds);

	for (c=0; c<(int)sizeof(MODE_INFO); c++)
		_farnspokeb(MASK_LINEAR(__tb)+c, 0);

	r.x.ax = 0x4F01;
	r.x.di = RM_OFFSET(__tb);
	r.x.es = RM_SEGMENT(__tb);
	r.x.cx = mode;
	__dpmi_int(0x10, &r);
	if (r.h.ah) {
		printf("Int 0x10, ax=0x4F01 failed! ax=0x%02X\n", r.x.ax);
		return 0;
	}

	dosmemget(MASK_LINEAR(__tb), sizeof(MODE_INFO), &mode_info);

	if(mode_info.PhysBasePtr >= 0x100000){
		*phys_base_ptr = mode_info.PhysBasePtr;
		printf("PhysBasePtr:\t0x%08lX\n", *phys_base_ptr);
		return 1;
	}

	return 0;
}






static void readmsr(DWORD _ecx, DWORD* _edx, DWORD* _eax)
{
	DWORD _xedx, _xeax;

	asm volatile ("
		movl %2,%%ecx
		rdmsr
		movl %%edx,%0
		movl %%eax,%1

		":"=g"(_xedx),"=g"(_xeax)\
		 :"g"(_ecx)\
		 :"eax","ecx","edx"\
	);
	*_edx = _xedx;
	*_eax = _xeax;
}




static void writemsr(DWORD _ecx, DWORD _edx, DWORD _eax)
{
	asm volatile ("
		movl %0,%%ecx
		movl %1,%%edx
		movl %2,%%eax
		wrmsr

		":\
		 :"g"(_ecx),"g"(_edx),"g"(_eax)\
		 :"eax","ecx","edx"\
	);
}


static DWORD bclr(DWORD val, int pos)
{
	DWORD d0;

	d0 = 1;
	d0 = d0 << pos;
	d0 = 0xffffffff ^ d0;
	d0 = val & d0;
	return( d0 );
}

static DWORD bset(DWORD val, int pos)
{
	DWORD d0;

	d0 = 1;
	d0 = d0 << pos;
	d0 = val | d0;
	return( d0 );
}


/* from MAME ticker.c */
static int cpu_mtrr(void)
{
	int result;

	__asm__ (
		"movl $1,%%eax		 ; "
		"xorl %%ebx,%%ebx  ; "
		"xorl %%ecx,%%ecx  ; "
		"xorl %%edx,%%edx  ; "
		"cpuid				 ; "
		"testl $0x1000,%%edx ; "
		"setne %%al 		 ; "
		"andl $1,%%eax		 ; "
	:  "=&a" (result)	/* the result has to go in eax */
	:		/* no inputs */
	:  "%ebx", "%ecx", "%edx" /* clobbers ebx ecx edx */
	);
	return result;
}


static int get_number_of_variable_range_registers(void)
{
	DWORD _edx, _eax;

	/* MTRR cap */
	readmsr(0xFE, &_edx, &_eax);

	return (_eax & 0xFF);
}


static int set_write_combining(QWORD base, QWORD size)
{
	DWORD _ecx, _edx, _eax;
	DWORD unused_mtrr;
	DWORD mtrr_start;
	QWORD mtrr_base;
	QWORD base_mask;
	QWORD mask;
	int num;
	int i;

	/*			C	8	4	0 */
	mask = 0xFFFFFFFFFFFFFFFF;
	while(size != 0){
		mask = mask << 1;
		size = size >> 1;
	}
	/*			   C   8   4   0 */
	if(mask > 0xFFFFFFFFFFFFF000) return 0;

	/*				 C	 8	 4	 0 */
	base_mask = 0xFFFFFFFFFFFFF000;
	base = base & base_mask;

	/* variable range MTRRs address start at 0x200 */
	mtrr_start = 0x200;

	unused_mtrr = 0;
	num = get_number_of_variable_range_registers();
	i = 0;
	while(i < num){
		/* MTRR address */
		_ecx = mtrr_start + (i * 2);

		/* get MTRR physical base */
		readmsr(_ecx, &_edx, &_eax);
		mtrr_base = ((QWORD)_edx << 32) | _eax;
		mtrr_base = mtrr_base & base_mask;
		if(mtrr_base == base){
			/* same physical base addess found */
			unused_mtrr = _ecx;
			break;
		}
		/* get MTRR mask */
		readmsr(_ecx + 1, &_edx, &_eax);
		if((_eax & 0x0800) == 0){
			/* unused MTRR found */
			if(unused_mtrr == 0) unused_mtrr = _ecx;
		}
		i += 1;
	}
	if(unused_mtrr == 0) return 0;		/* no unused MTRR found */

	base = base | 0x01; 				/* set write combining */
	mask = mask | 0x0800;				/* enable register pair */

	/* set to MTRRs */
	_edx = (base >> 32) & 0x0000000F;
	_eax = base & 0xFFFFFFFF;
	writemsr(unused_mtrr, _edx, _eax);

	_edx = (mask >> 32) & 0x0000000F;
	_eax = mask & 0xFFFFFFFF;
	writemsr(unused_mtrr + 1, _edx, _eax);

	return 1;
}



int main(int argc, char** argv)
{
	DWORD _ecx, _edx, _eax;
	DWORD mtrr_max;
	int d0;
	int number_of_modes;
	int vesa_major_version;
	DWORD memsize;
	DWORD phys_base_ptr;
	WORD mode[MAX_VESA_MODES];

	allegro_init();

	if(!cpu_cpuid){
		printf("Intel compatible MTRR required\n");
		return 0;
	}
	if(!cpu_mtrr()){
		printf("Intel compatible MTRR required\n");
		return 0;
	}

	if(get_vesa_info(mode, &number_of_modes, &vesa_major_version, &memsize) != 0)
		return 0;

	if(vesa_major_version < 2){
		printf("VESA2 and higher required\n");
		return 0;
	}

	phys_base_ptr = 0;
	d0 = 0;
	while(d0 < number_of_modes){
		if(get_mode_info(mode[d0], &phys_base_ptr) != 0) break;
		d0 += 1;
	}

	if(phys_base_ptr == 0){
		printf("no valid PhysBasePtr found\n");
		return 0;
	}

//	  return 0;


	d0 = set_write_combining(phys_base_ptr, memsize);
	if(d0 == 0){
		printf("set wc failed\n");
	}

	printf("\n");
	printf("MTRRs\n");

	_ecx = 0x200;
	d0 = get_number_of_variable_range_registers();
	mtrr_max = _ecx + (d0 * 2);
	while(_ecx < mtrr_max){
		readmsr(_ecx,	&_edx, &_eax);
		printf("Base%d	%1x : %8x\n", (_ecx & 0xF) / 2, _edx, _eax);
		readmsr(_ecx+1, &_edx, &_eax);
		printf("Mask%d	%1x : %8x\n", (_ecx & 0xF) / 2, _edx, _eax);
		_ecx += 2;
	}

	return 1;
}
